/*
 * JBoss, Home of Professional Open Source.
 * See the COPYRIGHT.txt file distributed with this work for information
 * regarding copyright ownership.  Some portions may be licensed
 * to Red Hat, Inc. under one or more contributor license agreements.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 * Modified by
 * @author  Data Virtuality GmbH
 * @date    $Date$
 *  
 */
// https://issues.jboss.org/browse/TEIID-2904
package org.teiid.deployers;

import java.util.ArrayList;
import java.util.Arrays;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

@SuppressWarnings("nls")
public class TestExtendedPropertyMetadata {

	@Test
	public void testDefault() {
		ExtendedPropertyMetadata metadata = new ExtendedPropertyMetadata("x", "java.lang.String", "some-name", null);
		
		Assertions.assertEquals("some-name", metadata.display());
		Assertions.assertEquals(null, metadata.description());
		Assertions.assertEquals(false, metadata.advanced());
		Assertions.assertEquals(false, metadata.required());
		Assertions.assertEquals(false, metadata.masked());
		Assertions.assertEquals(false , metadata.readOnly());
	}
	
	@Test
	public void testFormatted() {
		ArrayList<String> allowed =  new ArrayList<String>();
		allowed.add("get");
		allowed.add("post");
		
		ExtendedPropertyMetadata metadata = new ExtendedPropertyMetadata("x", "java.lang.String", "{$display:\"Is Immutable\",$description:\"True if the source never changes.\",$allowed:[\"get\",\"post\"], $required:\"true\",$advanced:\"true\"}", null);
		
		Assertions.assertEquals("Is Immutable", metadata.display());
		Assertions.assertEquals("True if the source never changes.", metadata.description());
		Assertions.assertEquals(true, metadata.advanced());
		Assertions.assertEquals(true, metadata.required());
		Assertions.assertEquals(false, metadata.masked());
		Assertions.assertEquals(false , metadata.readOnly());		
		Assertions.assertEquals(allowed , Arrays.asList(metadata.allowed()));
	}
	
	@Test
	public void testFormattedExtraCommasAndColons() {
		ArrayList<String> allowed =  new ArrayList<String>();
		allowed.add("get");
		allowed.add("post");
		
		ExtendedPropertyMetadata metadata = new ExtendedPropertyMetadata("x", "java.lang.String","{$display:\"Is Immu:table\",$description:\"True if the, source never changes.\",$allowed:[\"get\",\"post\"], $required:\"true\",$advanced:\"true\"}", null);
		
		Assertions.assertEquals("Is Immu:table", metadata.display());
		Assertions.assertEquals("True if the, source never changes.", metadata.description());
		Assertions.assertEquals(true, metadata.advanced());
		Assertions.assertEquals(true, metadata.required());
		Assertions.assertEquals(false, metadata.masked());
		Assertions.assertEquals(false , metadata.readOnly());		
		Assertions.assertEquals(allowed , Arrays.asList(metadata.allowed()));
	}	
	
	@Test
	public void testBlankProperties() {
		ArrayList<String> allowed =  new ArrayList<String>();
		allowed.add("get");
		allowed.add("post");
		
		ExtendedPropertyMetadata metadata = new ExtendedPropertyMetadata("x", "java.lang.String","{$display:\"Is Immutable\",$description:\"\",$allowed:[\"get\",\"post\"], $required:\"true\",$advanced:\"true\"}", null);
		
		Assertions.assertEquals("Is Immutable", metadata.display());
		Assertions.assertEquals("", metadata.description());
		Assertions.assertEquals(true, metadata.advanced());
		Assertions.assertEquals(true, metadata.required());
		Assertions.assertEquals(false, metadata.masked());
		Assertions.assertEquals(false , metadata.readOnly());		
		Assertions.assertEquals(allowed , Arrays.asList(metadata.allowed()));
	}	
}
